//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using Hsrm.Sila2.CpuUtilizationService.Contracts;
using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Hsrm.Sila2.CpuUtilizationService.CpuUtilizationService
{
    
    
    /// <summary>
    /// A class that exposes the ICpuUtilizationService interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class CpuUtilizationServiceProvider : IFeatureProvider
    {
        
        private ICpuUtilizationService _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(CpuUtilizationServiceProvider).Assembly, "CpuUtilizationService.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public CpuUtilizationServiceProvider(ICpuUtilizationService implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableProperty("CpuModel", GetCpuModel);
            registration.RegisterUnobservableProperty("CpuUtilization", GetCpuUtilization);
        }
        
        /// <summary>
        /// Gets the current value of the Cpu Model property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.StringDto> GetCpuModel()
        {
            return new PropertyResponse<Tecan.Sila2.StringDto>(new Tecan.Sila2.StringDto(_implementation.CpuModel, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Cpu Utilization property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<System.Collections.Generic.List<Tecan.Sila2.RealDto>> GetCpuUtilization()
        {
            return new PropertyResponse<System.Collections.Generic.List<Tecan.Sila2.RealDto>>(Tecan.Sila2.DtoExtensions.Encapsulate(_implementation.CpuUtilization, Tecan.Sila2.RealDto.Create, _server));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            if ((propertyIdentifier == "de.hsrm/tools/CpuUtilizationService/v1/Property/CpuModel"))
            {
                return typeof(ICpuUtilizationService).GetProperty("CpuModel");
            }
            if ((propertyIdentifier == "de.hsrm/tools/CpuUtilizationService/v1/Property/CpuUtilization"))
            {
                return typeof(ICpuUtilizationService).GetProperty("CpuUtilization");
            }
            return null;
        }
    }
}


